"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCFExportNameUserPoolClientIdFromConfig = exports.getCFExportNameUserPoolIdFromConfig = exports.getQpqRuntimeResourceNameFromConfig = exports.getQpqRuntimeResourceName = exports.getConfigRuntimeResourceNameFromConfig = exports.getConfigRuntimeResourceName = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const getConfigRuntimeResourceName = (resourceName, application, service, environment, feature) => {
    const baseName = `${resourceName}-${application}-${service}-${environment}`;
    if (feature) {
        return `${baseName}-${feature}`;
    }
    return baseName;
};
exports.getConfigRuntimeResourceName = getConfigRuntimeResourceName;
const getConfigRuntimeResourceNameFromConfig = (resourceName, qpqConfig) => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
};
exports.getConfigRuntimeResourceNameFromConfig = getConfigRuntimeResourceNameFromConfig;
const getQpqRuntimeResourceName = (resourceName, application, service, environment, feature, resourceType = '') => {
    const name = (0, exports.getConfigRuntimeResourceName)(resourceName, application, service, environment, feature);
    return `${name}-qpq${resourceType}`;
};
exports.getQpqRuntimeResourceName = getQpqRuntimeResourceName;
const getQpqRuntimeResourceNameFromConfig = (resourceName, qpqConfig, resourceType = '') => {
    const application = quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(resourceName, application, service, environment, feature, resourceType);
};
exports.getQpqRuntimeResourceNameFromConfig = getQpqRuntimeResourceNameFromConfig;
const getCFExportNameUserPoolIdFromConfig = (userDirectoryName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(userDirectoryName, application, service, environment, feature, 'user-pool-id-export');
};
exports.getCFExportNameUserPoolIdFromConfig = getCFExportNameUserPoolIdFromConfig;
const getCFExportNameUserPoolClientIdFromConfig = (userDirectoryName, qpqConfig, serviceOverride, applicationOverride) => {
    const application = applicationOverride || quidproquo_core_1.qpqCoreUtils.getApplicationName(qpqConfig);
    const service = serviceOverride || quidproquo_core_1.qpqCoreUtils.getApplicationModuleName(qpqConfig);
    const environment = quidproquo_core_1.qpqCoreUtils.getApplicationModuleEnvironment(qpqConfig);
    const feature = quidproquo_core_1.qpqCoreUtils.getApplicationModuleFeature(qpqConfig);
    return (0, exports.getQpqRuntimeResourceName)(userDirectoryName, application, service, environment, feature, 'user-pool-client-id-export');
};
exports.getCFExportNameUserPoolClientIdFromConfig = getCFExportNameUserPoolClientIdFromConfig;
